function strawberry_initialise
  global strawberry_version
  global strawberry_numberofprocessors
  global strawberry_octave
  global moga_version
  global mosd_version
  if isempty (strawberry_version)
    strawberry_version = '2018.05.30 12:05:00';
    mosd_initialise
    moga_initialise
    fprintf (': STRAWBERRY %s, main function\n', strawberry_version)
    fprintf (': using MOSD %s, multi-objective steepest descent method.\n', mosd_version)
    fprintf (': and MOGA %s, multi-objective genetic algorithm fitness function.\n', moga_version)
    strawberry_octave = exist ('OCTAVE_VERSION', 'builtin') > 0;
    if strawberry_octave
      fprintf(': running in Octave\n')
      if strawberry_numberofprocessors > 1
        pkg load parallel             %need parcellfun in particular
      end
    end
  end

global strawberry_neighbourfn
global strawberry_randomsolutionfn
if isempty(strawberry_randomsolutionfn)
  strawberry_randomsolutionfn = @strawberry_randomsolution;
  fprintf (': using default random solution generator function.\n');
end
if isempty(strawberry_neighbourfn)
  strawberry_neighbourfn = @strawberry_neighbour;
  fprintf (': using default neighbouring solution generator function.\n')
end
