function fit = strawberry_vectorfitness(m,v)
  %% println("VF: v=$v")
  %% println("  : of size $(size(v))")
  if m == 1                   % single objective 
    l = length(v);
    [sorted indices] = sort(v);
    zmin = v(indices(1));
    zmax = v(indices(l));
    if l == 1 || abs(zmax-zmin) < eps()
      fit = 0.5*ones(1,l);
    else
      %% avoid extreme 0,1 values
      fit = tanh((zmax - v) / (zmax - zmin) - 0.5)+0.5;
    end
  else                  % multi-objective
    [m, l] = size(v);
    rank = ones(m,l); %rank of each solution for each objective function 
    for i=1:m
      [sorted indices] = sort(v(i,:));
      rank(i,indices) = 1:l;
    end
    %% hadamard product of ranks
    fitness = prod(rank);
    %% normalise and reverse meaning (1=best, 0=worst)
    if l == 1
      fit = 0.5;
    else
      %% avoid extreme 0,1 values
      fit = tanh(0.5 - fitness / max(fitness)) + 0.5;
    end
  end
  %% println("VF: fit=$fit")
end
